%{?mingw_package_header}

Name:           mingw-libusbx
Version:        1.0.27
Release:        2%{?dist}
Summary:        MinGW library which allows userspace access to USB devices

License:        LGPLv2+
URL:            https://libusb.info
Source0:        https://github.com/libusb/libusb/releases/download/v%{version}/libusb-%{version}.tar.bz2

#upstream patch
Patch0001 : 0001-sunos-Fix-typos-breaking-build.patch
Patch0002 : 0002-Add-clang-tidy-config-file.patch
Patch0003 : 0003-hotplug_exit-Remove-parents-recursively.patch
Patch0004 : 0004-hotplug_exit-Mutex-protection-of-context-device-list.patch
Patch0005 : 0005-emscripten-Remove-superfluous-capability.patch
Patch0006 : 0006-xusb-Avoid-warning-about-implicit-switch-fallthrough.patch
Patch0007 : 0007-Fix-most-warnings-about-implicit-sign-conversion.patch
Patch0008 : 0008-darwin-Correct-interpretation-of-COM-style-Release-r.patch
Patch0009 : 0009-xcode-Enable-several-additional-warnings-in-the-Xcod.patch
Patch0010 : 0010-darwin-Fix-clang-static-analyzer-warning-about-a-var.patch
Patch0011 : 0011-darwin-Suppress-false-positive-warning-with-an-asser.patch
Patch0012 : 0012-haiku-Use-gcc-atomic-builtins-to-fix-build.patch
Patch0013 : 0013-Increase-usbi_get_tid-size-from-int-to-long.patch
Patch0014 : 0014-darwin-Cleanup-of-usbi_backend-structure.patch
Patch0015 : 0015-Add-support-for-SuperSpeed-Capability-Descriptors.patch
Patch0016 : 0016-Add-API-support-for-LIBUSB_SPEED_SUPER_PLUS_X2-20Gbp.patch
Patch0017 : 0017-windows-Restore-behaviour-of-skipping-malformed-devi.patch
Patch0018 : 0018-SuperSpeedPlus-Fix-typo-mantisa-mantissa-in-struct-f.patch
Patch0019 : 0019-linux-Fix-type-of-open-flags-argument.patch
Patch0020 : 0020-linux-ioctl-request-number-is-unsigned-long.patch
Patch0021 : 0021-xusb-Only-retrieve-BOS-descriptor-for-bcdUSB-0x0201-.patch
Patch0022 : 0022-Cosmetic-cleanup-of-SuperSpeedPlus-comments.patch
Patch0023 : 0023-windows-Downgrade-get_guid-DeviceInterfaceGUID-messa.patch
Patch0024 : 0024-Consistent-use-of-C-style-comment-markers.patch
Patch0025 : 0025-descriptor-Replace-parse_descriptor-function.patch
Patch0026 : 0026-descriptor-Defer-potentially-truncating-cast-to-last.patch
Patch0027 : 0027-descriptor-Restore-implicitly-casted-away-const.patch
Patch0028 : 0028-descriptor-Fix-potential-offsetting-of-pointer-by-to.patch
Patch0029 : 0029-descriptor-Small-clarifications-with-no-behaviour-ch.patch
Patch0030 : 0030-descriptor-Avoid-buffer-over-increment-in-parse_iad_.patch
Patch0031 : 0031-Emscripten-Avoid-uncaught-TypeError-on-browsers-with.patch
Patch0032 : 0032-examples-ezusb-Replace-rewind-with-fseek-to-check-fo.patch
Patch0033 : 0033-examples-fxload-Eliminate-all-reserved-C-identifiers.patch
Patch0034 : 0034-examples-xusb-Make-all-macro-replacement-lists-paren.patch
Patch0035 : 0035-examples-xusb-Make-some-parameters-const-where-possi.patch
Patch0036 : 0036-examples-xusb-Match-size-of-loop-index-to-what-is-it.patch
Patch0037 : 0037-darwin-Always-use-uppercase-literal-suffixes-for-imp.patch
Patch0038 : 0038-darwin-Explicitly-compare-string-compare-function-re.patch
Patch0039 : 0039-darwin-Fix-multiplication-overflow-by-better-matchin.patch
Patch0040 : 0040-Avoid-assignments-within-if-statements.patch
Patch0041 : 0041-descriptor-Eliminate-all-duplicate-branch-bodies-as-.patch
Patch0042 : 0042-descriptor-Fix-addition-overflow-by-correcting-casts.patch
Patch0043 : 0043-libusb.h-Match-parameter-names-in-declaration-and-de.patch
Patch0044 : 0044-clang-tidy-Stop-suppressing-readability-misleading-i.patch
Patch0045 : 0045-xusb-Define-proper-exit-status.patch
Patch0046 : 0046-Add-KEYS-file-for-release-files-verification.patch
Patch0047 : 0047-Replace-atoi-with-strtol-which-allows-error-checking.patch
Patch0048 : 0048-netbsd-Debug-print-all-errors.patch
Patch0049 : 0049-openbsd-Use-default-clause-in-_errno_to_libusb.patch
Patch0050 : 0050-windows-Base-HID-device-descriptor-on-cached-values.patch
Patch0051 : 0051-examples-ezusb-Fix-error-checking-regression-in-rece.patch
Patch0052 : 0052-xcode-Adjust-file-indentation-settings.patch
Patch0053 : 0053-descriptor-Fix-clang-Wimplicit-int-conversion-warnin.patch
Patch0054 : 0054-winusb-Fix-winusb_get_device_list-failing-to-find-po.patch

# Windows Hotplug Implement
Patch0055 : 0055-example-hotplugtest-Ignore-unavailable-devices.patch
Patch0056 : 0056-tests-stress_mt-ignore-errors-in-threads-for-checkin.patch
Patch0057 : 0057-windows-hotplug-implementation.patch
Patch0058 : 0058-windows-hotplug-implementation-use-PDEV_BROADCAST_DE.patch
Patch0059 : 0059-windows-Improve-hotplug-reliability.patch
Patch0060 : 0060-Format-code-style.patch

BuildArch:      noarch
BuildRequires:  make automake autoconf libtool
BuildRequires:  mingw32-filesystem >= 95
BuildRequires:  mingw64-filesystem >= 95
BuildRequires:  mingw32-gcc
BuildRequires:  mingw64-gcc


%description
This package provides a way for applications to access USB devices.

%package -n mingw32-libusbx
Summary:        MinGW library which allows userspace access to USB devices
Requires:       pkgconfig

%description -n mingw32-libusbx
This package contains the header files and libraries needed to develop
applications that use libusbx.

%package -n mingw32-libusbx-static
Summary:        MinGW static library which allows userspace access to USB devices
Requires:       mingw32-libusbx = %{version}-%{release}

%description -n mingw32-libusbx-static 
This package contains the static libraries needed to develop
applications that use libusbx.

%package -n mingw64-libusbx
Summary:        MinGW library which allows userspace access to USB devices
Requires:       pkgconfig

%description -n mingw64-libusbx
This package contains the header files and libraries needed to develop
applications that use libusbx.

%package -n mingw64-libusbx-static
Summary:        MinGW static library which allows userspace access to USB devices
Requires:       mingw64-libusbx = %{version}-%{release}

%description -n mingw64-libusbx-static
This package contains the static libraries needed to develop
applications that use libusbx.

%{?mingw_debug_package}


%prep
%autosetup -n libusb-%{version} -p1
autoreconf -fvi

%build
%mingw_configure
%mingw_make %{?_smp_mflags} V=1


%install
%mingw_make_install "DESTDIR=$RPM_BUILD_ROOT"

# Libtool files don't need to be bundled
find $RPM_BUILD_ROOT -name "*.la" -delete


%files -n mingw32-libusbx
%doc AUTHORS COPYING README NEWS
%{mingw32_bindir}/libusb-1.0.dll
%{mingw32_includedir}/libusb-1.0/
%{mingw32_libdir}/libusb-1.0.dll.a
%{mingw32_libdir}/pkgconfig/libusb-1.0.pc

%files -n mingw32-libusbx-static
%{mingw32_libdir}/libusb-1.0.a

%files -n mingw64-libusbx
%doc AUTHORS COPYING README NEWS
%{mingw64_bindir}/libusb-1.0.dll
%{mingw64_includedir}/libusb-1.0/
%{mingw64_libdir}/libusb-1.0.dll.a
%{mingw64_libdir}/pkgconfig/libusb-1.0.pc

%files -n mingw64-libusbx-static
%{mingw64_libdir}/libusb-1.0.a


%changelog
* Mon Sep 09 2024 Yupeng Chang <ypchang@ambarella.com> - 1.0.27-2
- Update to latest git
- Apply upstream patch to enable hotplug for Windows

* Wed Feb 21 2024 Yupeng Chang <ypchang@ambarella.com> - 1.0.27-1
- Update to 1.0.27
- Apply upstream patch to enable hotplug for Windows

* Thu Jul 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.24-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.24-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.24-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Fri Mar 25 2022 Sandro Mani <manisandro@gmail.com> - 1.0.24-5
- Rebuild with mingw-gcc-12

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.24-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Tue Sep  7 2021 Daniel P. Berrangé <berrange@redhat.com> - 1.0.24-3
- Update URL to point to a working website

* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.24-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Thu Feb 11 2021 Victor Toso <victortoso@redhat.com> - 1.0.24-1
- Update to 1.0.24

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.22-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Tue Jul 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.22-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Wed Jan 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.22-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Tue Oct 08 2019 Sandro Mani <manisandro@gmail.com> - 1.0.22-4
- Rebuild (Changes/Mingw32GccDwarf2)

* Thu Jul 25 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.22-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Fri Feb 01 2019 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.22-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Tue Aug 07 2018 Victor Toso <victortoso@redhat.com> - 1.0.22-1
- Update to 1.0.22

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.21-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Thu Feb 08 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.21-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.21-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.21-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Tue Oct 25 2016 Pavel Grunt <pgrunt@redhat.com> - 1.0.21-1
- Update to 1.0.21 and enable UsbDk

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.19-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.19-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Wed Nov 19 2014 Richard Hughes <richard@hughsie.com> - 1.0.19-1
- Update to 1.0.19

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.15-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.15-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Jun 27 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 1.0.15-1
- Updated to match with f19. rhbz#974701

* Mon May 20 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 1.0.12-2
- Bump to fix broken upgrade path from f17 to f18

* Sun Nov 18 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 1.0.12-1
- Update to upstream 1.0.12

* Fri Jul 20 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.11-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Mon May 21 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 1.0.9-1
- Initial packaging
